<?PHP



# QSS Qmail-Scanner Statistics



# ---------------------------------------------------------------------------

#

# Copyright (C) 2002 Alexandre Georges



# This program is free software; you can redistribute it and/or

# modify it under the terms of the GNU General Public License

# as published by the Free Software Foundation; either version 2

# of the License, or (at your option) any later version.



# This program is distributed in the hope that it will be useful,

# but WITHOUT ANY WARRANTY; without even the implied warranty of

# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the

# GNU General Public License for more details.



# You should have received a copy of the GNU General Public License

# along with this program; if not, write to the Free Software

# Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.



# Please read the README file for more information on this software.



# ---------------------------------------------------------------------------





# create image

$image = imageCreate(500,240);



# allocate all required colors

$colorWhite = imageColorAllocate($image, 255, 255, 255);

$colorBlack = imageColorAllocate($image, 0, 0, 0);

$colorVeryLightGrey = imageColorAllocate($image, 238, 238, 238);

$colorLightGrey = imageColorAllocate($image, 204, 204, 204);

$colorDarkGrey = imageColorAllocate($image, 102, 102, 102);



# Graph colors - Uses RGB codes

$blue1 = imageColorAllocate($image, 255, 0, 0);

$blue2 = imageColorAllocate($image, 0, 0, 255);

$blue3 = imageColorAllocate($image, 0, 255, 0);

$blue4 = imageColorAllocate($image, 255, 255, 0);

$blue5 = imageColorAllocate($image, 0, 255, 255);

$blue6 = imageColorAllocate($image, 153, 0, 0);

$blue7 = imageColorAllocate($image, 0, 0, 153);

$blue8 = imageColorAllocate($image, 0, 153, 0);

$blue9 = imageColorAllocate($image, 153, 153, 0);

$blue10 = imageColorAllocate($image, 0, 153, 153);



# clear the image space with the background color

imageFilledRectangle($image, 0, 0, 500, 240, $colorLightGrey);



# internal rectangle

imageFilledRectangle($image, 5, 5, 255, 235, $colorWhite);

imageRectangle($image, 5, 5, 255, 235, $colorBlack);



# graph background

imageFilledRectangle($image, 10, 10, 250, 230, $colorVeryLightGrey);



# background ellipse

$angle = 0;

while ($angle <= 2*pi()) {

	$x1 = 130 + 115 * cos($angle);

	$y1 = 125 + 100 * sin($angle);

	$angle = $angle + (pi()/1000);

	$x2 = 130 + 115 * cos($angle);

	$y2 = 125 + 100 * sin($angle);

	imageline($image, $x1, $y1, $x2, $y2, $colorBlack);

}

imagefilltoborder($image, 130, 125, $colorBlack, $colorBlack);



# slices

$count = count($points);

for ($i = 0; $i < $count; $i++) {


	# angles

	$a = round($points[$i][value] / 100 * 360);

	if ($i == $count-1) {

		$a = 360;

	} else {

		$a = $da + $a;

	}

	

	

	# color

	$color = "blue".($i+1);

	

	# arc

	$angle = deg2rad($da);

	$ab1 = $angle;

	imageline($image, 130, 115, 130+115*cos($angle), 115+100*sin($angle), $$color);

	while ($angle <= (deg2rad($a)-(pi()/1000))) {

		$x1 = 130 + 115 * cos($angle);

		$y1 = 115 + 100 * sin($angle);

		$angle = $angle + (pi()/1000);

		$x2 = 130 + 115 * cos($angle);

		$y2 = 115 + 100 * sin($angle);

		imageline($image, $x1, $y1, $x2, $y2, $$color);

	}

	imageline($image, 130, 115, 130+115*cos(deg2rad($a)), 115+100*sin(deg2rad($a)), $$color);

	$ab2 = $angle;

	imagefilltoborder($image, 130+57*cos(($ab2+$ab1)/2), 115+50*sin(($ab2+$ab1)/2), $$color, $$color);

	

	# angle

	$da = $a;

	

	# scale
                

	imagefilledrectangle($image, 280, 15+($i*21), 300, 30+($i*21), $$color);

	imagerectangle($image, 280, 15+($i*21), 300, 30+($i*21), $colorBlack);

	$string = trim($points[$i][value]."%");

	imagestring($image, 2, 310, 17+($i*21), $string, $colorBlack);

	$string = trim($points[$i][name]);

	imagestring($image, 2, 340, 17+($i*21), $string, $colorBlack);

}



# ellipse

$angle = 0;

while ($angle <= 2*pi()) {

	$x1 = 130 + 115 * cos($angle);

	$y1 = 115 + 100 * sin($angle);

	$angle = $angle + (pi()/1000);

	$x2 = 130 + 115 * cos($angle);

	$y2 = 115 + 100 * sin($angle);

	imageline($image, $x1, $y1, $x2, $y2, $colorBlack);

}



# final generation of the picture

imagePNG($image);



# clear the memory

imagedestroy($image);



?>


