<?PHP



# QSS Qmail-Scanner Statistics



# ---------------------------------------------------------------------------

#

# Copyright (C) 2002 Alexandre Georges



# This program is free software; you can redistribute it and/or

# modify it under the terms of the GNU General Public License

# as published by the Free Software Foundation; either version 2

# of the License, or (at your option) any later version.



# This program is distributed in the hope that it will be useful,

# but WITHOUT ANY WARRANTY; without even the implied warranty of

# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the

# GNU General Public License for more details.



# You should have received a copy of the GNU General Public License

# along with this program; if not, write to the Free Software

# Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.



# Please read the README file for more information on this software.



# ---------------------------------------------------------------------------





# create image

$image = imageCreate($config["imageWidth"], $config["imageHeight"]);



# allocate all required colors

$colorWhite = imageColorAllocate($image, 255, 255, 255);

$colorBlack = imageColorAllocate($image, 0, 0, 0);

$colorRed = imageColorAllocate($image, 255, 0, 0);

$colorGreen = imageColorAllocate($image, 0, 255, 0);

$colorBlue = imageColorAllocate($image, 0, 0, 255);

$colorLightBlue = imageColorAllocate($image, 0, 51, 102);

$colorVeryLightGrey = imageColorAllocate($image, 238, 238, 238);

$colorLightGrey = imageColorAllocate($image, 204, 204, 204);

$colorDarkGrey = imageColorAllocate($image, 102, 102, 102);



# clear the image space with the background color and print the border

imageFilledRectangle($image, 0, 0, $config["imageWidth"], $config["imageHeight"], $colorLightGrey);



# internal rectangle

imageFilledRectangle($image, 40, 10, $config["imageWidth"]-40, $config["imageHeight"]-30, $colorWhite);



# graph background

imageFilledRectangle($image, 45, 15, $config["imageWidth"]-45, $config["imageHeight"]-35, $colorVeryLightGrey);



# counts the number of points and calculate the max, min and average values

$datasInfos["max"] = 0;

$datasInfos["min"] = 999999999;

$datasInfos["average"] = 0;

$datasInfos["count"] = $config["stopCount"] - $config["startCount"] + 1;

while (list ($key, $val) = each ($points)) {

        if (($key >= $config["startCount"]) AND ($key <= $config["stopCount"])) {

                if ($val > $datasInfos["max"]) {

                        $datasInfos["max"] = $val;

                }

                if ($val < $datasInfos["min"]) {

                        $datasInfos["min"] = $val;

                }

                $datasInfos["average"] += $val;

        }

}

$datasInfos["average"] = round($datasInfos["average"] / $datasInfos["count"]);



# calculate informations about the graph

$graphHeight = $config["imageHeight"] - 40;

$graphWidth = $config["imageWidth"] - 80;



# print the vertical graduation and grid

$graphGrad = $config["maxGrad"];

if ($datasInfos["max"] < $graphGrad) {

        $graphGrad = $datasInfos["max"];

}

for ($i = 0; $i <= $graphGrad; $i++) {

        $stepVal = $datasInfos["max"] / $graphGrad;

        $stepPix = $stepVal / $datasInfos["max"] * $graphHeight;

        $y = $config["imageHeight"]-30-($stepPix*$i);

        if ($y < 10) {

                $y = 10;

        }

        imageLine($image, 40, $y, $config["imageWidth"]-40, $y, $colorLightGrey);

        imageLine($image, 37, $y, 40, $y, $colorBlack);

        $grad = round($i * $stepVal);

        if ($grad > 1000) {

                $grad = round($grad / 1000)."k";

        }

        while (strlen($grad) < 4) {

                $grad = " ".$grad;

        }

        imagestring($image, 2, 9, $y-6, $grad, $colorBlack);

}



# print the average line and value

$y = round($config["imageHeight"] - 30 - ($datasInfos["average"] / $datasInfos["max"] * $graphHeight));

imageLine($image, 40, $y, $config["imageWidth"]-37, $y, $colorRed);

if ($datasInfos["average"] > 1000) {

        $average = round($datasInfos["average"] / 1000)."k";

} else {

        $average = $datasInfos["average"];

}

imagestring($image, 1, $config["imageWidth"]-34, $y-3, $average, $colorRed);



# calculate cols' width

$interWidth = ($graphWidth - ($datasInfos["count"] * $config["minColsWidth"])) / ($datasInfos["count"] + 1);

if ($interWidth > $config["maxInter"]) {

        $interWidth = $config["maxInter"];

        $colsWidth = ($graphWidth - (($datasInfos["count"] + 1) * $config["maxInter"])) / $datasInfos["count"];

} else {

        $colsWidth = $config["minColsWidth"];

}



# print the graph

if ($config["startHGrad"]) {

        $hKey = $config["startHGrad"];

} else {

        $hKey = $config["startCount"];

}

$j=0;

for ($i = $config["startCount"]; $i <= $config["stopCount"]; $i++) {

        $value = $points[$i];

        if ($value > 1000) {

                $value = round($value / 1000)."k";

        }

        $x0 = 40 + $interWidth + ($j * ($interWidth + $colsWidth));

        $x1 = $x0 + $colsWidth;

        $x2 = $x0 + 1;

        $x3 = $x0 + 4;

        $y0 = round($config["imageHeight"] - 30 - ($points[$i] / $datasInfos["max"] * $graphHeight));

        $y1 = $config["imageHeight"] - 30;

        $y2 = $y0 + 1;

        imageRectangle($image, $x0, $y0, $x1, $y1, $colorBlack);

        if (($y1-$y0) > 1) {

			imageFillToBorder($image, $x2, $y2, $colorBlack, $colorLightBlue);

		}

        if (($y1 - $y0) > ((strlen($value) * 5) + 10)) {

                $y3 = $y0 + 5 + (strlen($value) * 5);

                imageStringUp($image, 1, $x3, $y3, $value, $colorWhite);

        } else {

                $y3 = $y0 - 5;

                imageStringUp($image, 1, $x3, $y3, $value, $colorBlack);

        }

		$m = "$hKey/10/1999 10:10";

		$m = strtotime($m);

		$m = date("M", $m);

        $x4 = $x0 + round($colsWidth / 2) - round((strlen($m) / 2) * 5);

        imageString($image, 2, $x4, $config["imageHeight"]- 25, $m, $colorBlack);

        if ($hKey == 12) {

			$hKey = 1;

		} else {

			$hKey++;

		}

		$j++;

}



# print the max and min values

$y = round($config["imageHeight"] - 30 - $graphHeight);

imageLine($image, $config["imageWidth"]-40, $y, $config["imageWidth"]-37, $y, $colorBlue);

imageString($image, 1, $config["imageWidth"]-34, $y-3, $datasInfos["max"], $colorBlue);

$y = round($config["imageHeight"] - 30 - ($datasInfos["min"] / $datasInfos["max"] * $graphHeight));

imageLine($image, $config["imageWidth"]-40, $y, $config["imageWidth"]-37, $y, $colorBlue);

imageString($image, 1, $config["imageWidth"]-34, $y-3, $datasInfos["min"], $colorBlue);



# graph border

imageRectangle($image, 40, 10, $config["imageWidth"]-40, $config["imageHeight"]-30, $colorBlack);



# final generation of the picture

imagePNG($image);



# clear the memory

imagedestroy($image);



?>



