<?PHP



# QSS Qmail-Scanner Statistics



# ---------------------------------------------------------------------------



# Copyright (C) 2002 Alexandre Georges



# This program is free software; you can redistribute it and/or

# modify it under the terms of the GNU General Public License

# as published by the Free Software Foundation; either version 2

# of the License, or (at your option) any later version.



# This program is distributed in the hope that it will be useful,

# but WITHOUT ANY WARRANTY; without even the implied warranty of

# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the

# GNU General Public License for more details.



# You should have received a copy of the GNU General Public License

# along with this program; if not, write to the Free Software

# Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.



# Please read the README file for more information on this software.



# ---------------------------------------------------------------------------





# Start counter

$counter = microtime();



# Parse the config file

include("config.php");



# Read the log file

$logFile = file($config["logFile"]);



# Generate the data array

$i = 1;

while (list($key, $val) = each($logFile)) {



	# Explode each line

	$val = explode("\t",$val);

	

	# Calc the date timestamp

	$date = explode("/",$val[0]);

	$dateT = $date[0];

	$date[0] = $date[1];

	$date[1] = $dateT;

	$date = strtotime(implode("/",$date));

	

	# Remove the user@domain. of the mails

	$domain = explode("@",$val[1]);

	

	# Generate a line of the array

	$data[] = $date."\t".$domain[1]."\t".$val[4];

	

	# Create information var

	if ($i == 1) {

		$virusDate = $val[0];

	}

	$i++;

}


# Create the information var

$virusCount = count($logFile);



# Generate the result array

$count = count($data);

$startTable = 1;

$rDom = array();

$rVir = array();

for ($i = 0; $i < 13; $i++) {

	

	# Calc the max and min timestamp

	$now = time();

	$dM = date("n",$now);

	$dY = date("Y",$now);

	if ($dM <= $i) {

		$dM = 12-($i-$dM);

		$dY = $dY-1;

	} else {

		$dM = $dM-$i;

	}

	$min = strtotime("$dM/1/$dY 00:00:00");

	$dD = date("t",$min);

	$max = strtotime("$dM/$dD/$dY 23:59:59");



	# Look for a time limit

	if (($dY == $config["startYear"]) AND ($dM == $config["startMonth"])) {

		$startTable = 12-$i;

	}



	# Check all records and takes out data to use

	$datas = array();

	reset($data);

	while (list($key, $val) = each($data)) {



		# Explode each line

		$line = explode("\t",$val);

		

		# Check the date

		if (($line[0] >= $min) AND ($line[0] <= $max)) {

			$datas[] = $val;

		}



	}

	

	# Generate the result line

	$rTotal = count($datas);

	$rDaily = number_format(($rTotal / $dD), 2);

	unset($dDom);

	unset($dVir);

	while (list($key, $val) = each($datas)) {

	

		# Explode each line

		$line = explode("\t",$val);

		

		# Count the domains

		$dDom[$line[1]]++;

		$ext = explode(".",$line[1]);

		end($ext);

		$ext = strtolower(current($ext));

		$rDom[$ext]++;

		

		# Count the viruses

		$dVir[$line[2]]++;

		$rVir[$line[2]]++;

		

	}

	$rrDom = count($dDom);

	$rrVir = count($dVir);

	$key = 12-$i;

	$kM = $dM;

	$dM = date("M",$max);

	$result[$key] = array("Month" => $dM, "Year" => $dY, "Daily" => $rDaily, "Viruses" => $rrVir, "Domains" => $rrDom, "Total" => $rTotal, "Mcode" => $kM);

	

}



# Generate graph link

$v = "s=".$result[$startTable][Mcode]."&data=";

for ($i = $startTable; $i < 12; $i++) {

	$v .= $result[$i][Total].",";

}

$v .= $result[12][Total];



# Sort the result arrays

arsort($rDom);

arsort($rVir);



# Create the ISO 3166 array

$isofile = file("iso3166");

while (list($key, $val) = each($isofile)) {

	$val = explode(";",$val);

	$val[0] = trim($val[0]);

	$val[0] = strtolower($val[0]);

	$val[0] = ucwords($val[0]);

	$val[1] = trim($val[1]);

	$val[1] = strtolower($val[1]);

	$iso[$val[1]] = $val[0];

}



?>



<html>

<head>

<title>Qmail-Scanner Statistics</title>

<meta http-equiv="Content-Type" content="text/html; charset=iso-8859-1">

<style>

.linkLog {  font-family: Verdana, Arial, Helvetica; font-size: 9px; color: #FFFFFF; text-decoration: none}

</style>

</head>



<body bgcolor="#FFFFFF" text="#000000" leftmargin="0" topmargin="0" marginwidth="0" marginheight="0">

<table width="100%" border="0" cellspacing="0" cellpadding="0" height="100%">

  <tr>

    <td valign="middle" align="center" height="1103"> 

      <table width="560" border="1" cellspacing="0" cellpadding="0" align="center" bordercolor="#FFFFFF">

        <tr bgcolor="#000000" bordercolor="#000000"> 

          <td height="15" valign="middle" align="center"><font face="Verdana, Arial, Helvetica, sans-serif" size="1" color="#FFFFFF">Log 

            File&nbsp;: 

            <?PHP print date("m/d/Y H:i",filemtime($config["logFile"])); ?>

            &nbsp;-&nbsp;&nbsp;Stats : 

            <?PHP print date("m/d/Y H:i",time()); ?>

            &nbsp;</font></td>

        </tr>

        <tr bordercolor="#000000" bgcolor="#6699CC"> 

          <td> &nbsp;<br>

            <table width="520" border="1" cellspacing="0" cellpadding="0" align="center" bordercolor="#000000">

              <tr> 

                <td width="20" bgcolor="#000000" bordercolor="#000000" height="20"><img src="images/q.gif" width="20" height="20"></td>

                <td width="500" bgcolor="#CCCCCC" bordercolor="#CCCCCC" valign="middle" align="center" height="20"> 

                  <b><img src="images/qss_title.gif" width="500" height="20"></b></td>

              </tr>

            </table>

            <br>

            <table width="527" border="1" cellspacing="0" cellpadding="0" align="center" bordercolor="#000000">

              <tr> 

                <td width="20" bgcolor="#000000" bordercolor="#000000" height="20"><img src="images/dot.gif" width="20" height="20"></td>

                <td width="500" bgcolor="#CCCCCC" bordercolor="#CCCCCC" valign="middle" align="center" height="20"> 

                  <font face="Verdana, Arial, Helvetica, sans-serif" size="1">Qmail-Scanner stopped <?PHP print($virusCount); ?> viruses since <?PHP print($virusDate); ?>.</font></td>

              </tr>

            </table>

            <br>

            <table width="520" border="1" cellspacing="0" cellpadding="0" align="center" bordercolor="#000000">

              <tr> 

                <td width="20" bgcolor="#000000" bordercolor="#000000"><img src="images/graph_title.gif" width="20" height="150"></td>

                <td width="500" bordercolor="#CCCCCC" bgcolor="#CCCCCC"><img src="getGraph1.php?<?PHP print($v); ?>" width="500" height="200"></td>

              </tr>

            </table>

            <br>

            <table width="520" border="1" cellspacing="0" cellpadding="0" align="center" bordercolor="#000000">

              <tr bordercolor="#CCCCCC"> 

                <td bgcolor="#000000" width="20" bordercolor="#000000"><img src="images/stats_title.gif" width="20" height="150"></td>

                <td bgcolor="#CCCCCC"> 

                  <table width="500" border="0" cellspacing="0" cellpadding="0" bordercolor="#666666">

                    <tr bordercolor="#CCCCCC"> 

                      <td bgcolor="#CCCCCC" width="100" height="25"> 

                        <div align="center"><font face="Verdana, Arial, Helvetica, sans-serif" size="1"><b>Month</b></font></div>

                      </td>

                      <td bgcolor="#CCCCCC" width="100" height="25"> 

                        <div align="center"><font face="Verdana, Arial, Helvetica, sans-serif" size="1"><b>Daily 

                          average </b></font></div>

                      </td>

                      <td bgcolor="#CCCCCC" width="100" height="25"> 

                        <div align="center"><font face="Verdana, Arial, Helvetica, sans-serif" size="1"><b>Viruses 

                          </b></font></div>

                      </td>

                      <td bgcolor="#CCCCCC" width="100" height="25"> 

                        <div align="center"><font face="Verdana, Arial, Helvetica, sans-serif" size="1"><b>Sources</b></font></div>

                      </td>

                      <td bgcolor="#CCCCCC" width="100" height="25"> 

                        <div align="center"><font face="Verdana, Arial, Helvetica, sans-serif" size="1"><b>Monthly 

                          total </b></font></div>

                      </td>

                    </tr>

                    <?PHP

					

					function getimg($a,$b) {

					

						if ($b <> 0) {

							$pc = ($a-round(($a+$b)/2))/$b*100;

						} elseif ($a == $b) {

							$pc = 0;

						} else {

							$pc = 100;

						}

						if ($pc < (-1*$config["tolerance"])) {

							$img = "down";

						} elseif ($pc > $config["tolerance"]) {

							$img = "up";

						} else {

							$img = "stab";

						}

						print("<img src='images/$img.gif' width='10' height='10' align='absmiddle'>");

					

					}

					

					for ($i = $startTable; $i <= 12; $i++) {

					

					?>

                    <tr bordercolor="#CCCCCC"> 

                      <td bgcolor="#CCCCCC" width="100" height="25"> 

                        <div align="center"><font face="Verdana, Arial, Helvetica, sans-serif" size="1"> 

                          <?PHP print($result[$i][Month]."&nbsp;".$result[$i][Year]); ?>

                          </font></div>

                      </td>

                      <td bgcolor="#CCCCCC" width="100" height="25"> 

                        <div align="center"><font face="Verdana, Arial, Helvetica, sans-serif" size="1"> 

                          <?PHP print($result[$i][Daily]); ?>

                          &nbsp;&nbsp; 

                          <?PHP getimg($result[$i][Daily],$result[$i-1][Daily]); ?>

                          </font></div>

                      </td>

                      <td bgcolor="#CCCCCC" width="100" height="25"> 

                        <div align="center"><font face="Verdana, Arial, Helvetica, sans-serif" size="1"> 

                          <?PHP print($result[$i][Viruses]); ?>

                          &nbsp;&nbsp; 

                          <?PHP getimg($result[$i][Viruses],$result[$i-1][Viruses]); ?>

                          </font></div>

                      </td>

                      <td bgcolor="#CCCCCC" width="100" height="25"> 

                        <div align="center"><font face="Verdana, Arial, Helvetica, sans-serif" size="1"> 

                          <?PHP print($result[$i][Domains]); ?>

                          &nbsp;&nbsp; 

                          <?PHP getimg($result[$i][Domains],$result[$i-1][Domains]); ?>

                          </font></div>

                      </td>

                      <td bgcolor="#CCCCCC" width="100" height="25"> 

                        <div align="center"><font face="Verdana, Arial, Helvetica, sans-serif" size="1"> 

                          <?PHP print($result[$i][Total]); ?>

                          &nbsp;&nbsp; 

                          <?PHP getimg($result[$i][Total],$result[$i-1][Total]); ?>

                          </font></div>

                      </td>

                    </tr>

                    <?PHP

					

					}

					

					?>

                  </table>

                </td>

              </tr>

            </table>

            <br>

            <table width="520" border="1" cellspacing="0" cellpadding="0" align="center" bordercolor="#000000">

              <tr bordercolor="#CCCCCC"> 

                <td bgcolor="#000000" width="20" bordercolor="#000000"><img src="images/viruses_title.gif"></td>

                <td bgcolor="#CCCCCC" width="500"><?PHP

							$i = 1;

							$pp = 0;

							reset($rVir);

							while ($i <= 10) {

								if (key($rVir) <> "") {

									$n = key($rVir);

								} else {

									$n = "Unknown";

								}

								$p = round(current($rVir)/$count*100);

								if ($p > $config["piePercent"]) {

									$pp += $p;

									$resultVir[$i][value] = $p;

									$resultVir[$i][name] = $n;

						 			$i++;

									next($rVir);

								} elseif (100-$pp > 0) {

									$j = $i;

									$resultVir[$j][value] = 100-$pp;

									$resultVir[$j][name] = "Others";

									$i = 100;

								} else {
                                                                        $i = 100;
                                                                }

						 	}

							while (list($key, $val) = each($resultVir)) {

								$param1 .= "$val[value],";

								$param2 .= "$val[name],";

							}

							$param1 = rawurlencode(substr($param1,0,-1));

							$param2 = rawurlencode(substr($param2,0,-1));

							print("<img src='getGraph.php?data=$param1&t=$param2'>"); 

						?></td>

              </tr>

            </table>

            <br>

            <table width="520" border="1" cellspacing="0" cellpadding="0" align="center" bordercolor="#000000">

              <tr bordercolor="#CCCCCC"> 

                <td bgcolor="#000000" width="20" bordercolor="#000000"><img src="images/sources_title.gif"></td>

                <td bgcolor="#CCCCCC" width="500"><?PHP

							$i = 1;

							$pp = 0;

							reset($rDom);

							while ($i <= 10) {

								if (key($rDom) <> "") {

									$n = key($rDom);

									$n = $iso[$n];

								} else {

									$n = "Unknown";

								}

								$p = round(current($rDom)/$count*100);

								if ($p > $config["piePercent"]) {

									$pp += $p;

									$resultDom[$i][value] = $p;

									$resultDom[$i][name] = $n;

						 			$i++;

									next($rDom);

								} elseif (100-$pp > 0) {
                                                                
									$j = $i;

									$resultDom[$j][value] = 100-$pp;

									$resultDom[$j][name] = "Others";

									$i = 100;

								} else {
                                                                        $i = 100;
                                                                }

						 	}

							unset($param1);

							unset($param2);

							while (list($key, $val) = each($resultDom)) {

								$param1 .= "$val[value],";

								$param2 .= "$val[name],";

							}

							$param1 = rawurlencode(substr($param1,0,-1));

							$param2 = rawurlencode(substr($param2,0,-1));

							print("<img src='getGraph.php?data=$param1&t=$param2'>"); 

						?></td>

              </tr>

            </table>

            &nbsp; &nbsp; </td>

        </tr>

        <tr bgcolor="#000000" align="center"> 

          <td bordercolor="#000000" height="15"><font face="Verdana, Arial, Helvetica, sans-serif" size="1" color="#FFFFFF"><a href="http://sourceforge.net/projects/qss/" class="linkLog">QSS 

            2.0.2</a> - Stats generated in 

            <?PHP 

			

			$counter = explode(" ", $counter);

			$counter = $counter[0] + $counter[1];

			

			$counter_stop = microtime();



			$counter_stop = explode(" ", $counter_stop);

			$counter_stop = $counter_stop[0] + $counter_stop[1];

			

			$result = $counter_stop - $counter;

			print number_format($result, 2); 

			

			?>

            second(s)</font></td>

        </tr>

      </table>

    </td>

  </tr>

</table>

</body>

</html>
